Public Class Form1
    Private Sub btnProcessPayroll_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcessPayroll.Click
        ProcessPayroll()
    End Sub

    Private Sub ProcessPayroll()
        ' Load the payroll file.
        On Error GoTo LoadPayrollError
        LoadPayrollFile()

        On Error GoTo PrintPaychecksError
        ' Print paychecks.
        PrintPaychecks()

        ' We're done.
        Exit Sub

LoadPayrollError:
        MessageBox.Show("Error loading the payroll file.")
        Exit Sub

PrintPaychecksError:
        MessageBox.Show("Error printing paychecks.")
        Exit Sub
    End Sub

    Private Sub LoadPayrollFile()
        On Error Resume Next
        DoSomething()
        If Err.Number <> 0 Then
            MessageBox.Show("Error in DoSomething")
            Exit Sub
        End If

        DoSomethingElse()
        If Err.Number <> 0 Then
            MessageBox.Show("Error in DoSomethingElse")
            Exit Sub
        End If
    End Sub

    Private Sub DoSomething()
        Dim X As Integer

        ' Try to calculate X.
        On Error Resume Next
        X = CalculateValue()

        Select Case Err.Number
            Case 0       ' No error. Do nothing.
            Case 11      ' Divide by zero. Set a default value.
                X = 1000
            Case Else    ' Unexpected error. Tell the user.
                MessageBox.Show("Error calculating X." & vbCrLf & Err.Description)
                Exit Sub
        End Select
    End Sub

    Private Function CalculateValue() As Integer
        Dim i As Integer = 0
        Return 1 \ i
    End Function

    Private Sub DoSomethingElse()

    End Sub

    Private Sub PrintPaychecks()
        ' Throw an error.
        Throw New System.FormatException()
    End Sub

End Class
